跳到主要内容

如何使用 Vue 更改节点的 zIndex?

如何在 vue-konva 中更改 zIndex 并重新排列组件?

直接使用 Konva 时,可以通过 node.zIndex(5)node.moveToTop() 等多种方法更改节点顺序。有关详细信息,请参阅图层顺序教程

但是,使用 Vue 时,建议遵循 Vue 的声明式方法,而不是使用这些命令式方法。

vue-konva 会严格按照 <template> 中描述节点的顺序进行渲染。不要手动更改 zIndex,而应更新应用数据,确保 <template> 中的组件保持正确顺序。

此示例展示如何:

  1. 创建具有随机位置和颜色的圆形数组
  2. 处理拖动事件,以更新图形的视觉顺序
  3. 通过调整数组顺序来保持正确的堆叠顺序
  4. 使用 Vue 响应式系统管理 state

请记住:不要对 Canvas 组件使用 zIndex 属性。应依靠模板和数据结构中的元素顺序。

操作说明:尝试拖动圆形。开始拖动时,圆形会自动移动到堆叠顶部。这通过调整数据中的圆形数组实现,而不是手动更改 zIndex。

<template>
  <v-stage :config="stageSize">
    <v-layer>
      <v-circle
        v-for="item in items"
        :key="item.id"
        :config="item"
        @dragstart="handleDragstart"
        @dragend="handleDragend"
      />
    </v-layer>
  </v-stage>
</template>

<script setup>
import { ref, onMounted } from 'vue';
import Konva from 'konva';

const stageSize = {
  width: window.innerWidth,
  height: window.innerHeight
};

const items = ref([]);
const dragItemId = ref(null);

const generateItems = () => {
  const newItems = [];
  for (let i = 0; i < 10; i++) {
    newItems.push({
      x: Math.random() * stageSize.width,
      y: Math.random() * stageSize.height,
      radius: 50,
      id: "node-" + i,
      fill: Konva.Util.getRandomColor(),
      draggable: true
    });
  }
  return newItems;
};

const handleDragstart = (e) => {
  // save drag element:
  dragItemId.value = e.target.id();
  // move current element to the top by rearranging the items array:
  const item = items.value.find(i => i.id === dragItemId.value);
  const index = items.value.indexOf(item);
  items.value.splice(index, 1);
  items.value.push(item);
};

const handleDragend = () => {
  dragItemId.value = null;
};

onMounted(() => {
  items.value = generateItems();
});
</script>

跳到主要内容

Angular Konva 层叠顺序教程

要在 Angular 中控制图形层叠顺序,请更新用于渲染图形的数据数组顺序。

本示例展示以下操作:

  1. 创建一个包含随机位置和颜色的圆形图形数组
  2. 处理拖动事件以更新图形的视觉顺序
  3. 通过操作数组顺序保持正确的层叠顺序
  4. 通过 Angular state 驱动渲染,而不是以命令式方式调用 zIndex()

操作说明:尝试拖动圆形。开始拖动时,它会自动移到层叠顶部。此示例通过操作数据中的圆形数组实现该效果,而不是手动更改 zIndex。

import { Component, OnInit } from '@angular/core';
import { StageConfig } from 'konva/lib/Stage';
import { CircleConfig } from 'konva/lib/shapes/Circle';

import {
  CoreShapeComponent,
  StageComponent,
} from 'ng2-konva';

@Component({
  selector: 'app-root',
  standalone: true,
  template: `
    <ko-stage [config]="configStage">
      <ko-layer>
        @for (item of items; track trackById($index, item)) {
          <ko-circle
            [config]="item"
            (dragstart)="handleDragstart($event.event)"
            (dragend)="handleDragend()"
          ></ko-circle>
        }
      </ko-layer>
    </ko-stage>
  `,
  imports: [StageComponent, CoreShapeComponent],
})
export default class App implements OnInit {
  public configStage: StageConfig = {
    width: window.innerWidth,
    height: window.innerHeight,
  };
  
  public items: CircleConfig[] = [];
  private dragItemId: string | null = null;

  ngOnInit() {
    this.generateItems();
  }

  private generateItems(): void {
    const newItems: CircleConfig[] = [];
    for (let i = 0; i < 10; i++) {
      newItems.push({
        x: Math.random() * this.configStage.width!,
        y: Math.random() * this.configStage.height!,
        radius: 50,
        id: "node-" + i,
        fill: this.getRandomColor(),
        draggable: true
      });
    }
    this.items = newItems;
  }

  private getRandomColor(): string {
    const colors = ['#FF6B6B', '#4ECDC4', '#45B7D1', '#96CEB4', '#FFEAA7', '#DDA0DD', '#98D8C8', '#F7DC6F', '#BB8FCE', '#85C1E9'];
    return colors[Math.floor(Math.random() * colors.length)];
  }

  public handleDragstart(event: any): void {
    this.dragItemId = event.target.id();
    const item = this.items.find(i => i.id === this.dragItemId);
    if (item) {
      this.items = [
        ...this.items.filter((i) => i.id !== this.dragItemId),
        item
      ];
    }
  }

  public handleDragend(): void {
    this.dragItemId = null;
  }

  public trackById(index: number, item: CircleConfig): string {
    return item.id as string;
  }
}

跳到主要内容

如何使用 React 更改节点的 zIndex?

如何在 react-konva 中更改 zIndex 并重新排序组件?

直接使用 Konva 时,可以通过多种方法更改节点顺序,例如 node.zIndex(5)node.moveToTop() 等。请参阅 教程

但使用 React 框架时,不建议使用这些方法。

react-konva 严格遵循组件中定义的节点顺序。因此,不要手动更改 zIndex,只需正确更新应用 state。

不要为 Canvas 组件使用 zIndex

如果要将节点临时移动到另一个容器,例如显示覆盖层,请参阅 Canvas Portal 示例

操作说明:尝试拖动圆形。观察它如何移动到最上层。此示例通过操作 state,使组件按正确顺序渲染。

import React, { Component } from 'react';
import Konva from 'konva';
import { Stage, Layer, Circle } from 'react-konva';

function generateItems() {
  const items = [];
  for (let i = 0; i < 10; i++) {
    items.push({
      x: Math.random() * window.innerWidth,
      y: Math.random() * window.innerHeight,
      id: 'node-' + i,
      color: Konva.Util.getRandomColor(),
    });
  }
  return items;
}

const App = () => {
  const [items, setItems] = React.useState(generateItems());

  const handleDragStart = (e) => {
    const id = e.target.name();
    const itemsCopy = items.slice();
    const item = itemsCopy.find((i) => i.id === id);
    const index = itemsCopy.indexOf(item);
    // remove from the list:
    itemsCopy.splice(index, 1);
    // add to the top
    itemsCopy.push(item);
    setItems(itemsCopy);
  };

  const onDragEnd = (e) => {
    const id = e.target.name();
    const itemsCopy = items.slice();
    const item = items.find((i) => i.id === id);
    const index = items.indexOf(item);
    // update item position
    itemsCopy[index] = {
      ...item,
      x: e.target.x(),
      y: e.target.y(),
    };
    setItems(itemsCopy);
  };

  return (
    <Stage width={window.innerWidth} height={window.innerHeight}>
      <Layer>
        {items.map((item) => (
          <Circle
            key={item.id}
            name={item.id}
            draggable
            x={item.x}
            y={item.y}
            fill={item.color}
            radius={50}
            onDragStart={handleDragStart}
            onDragEnd={onDragEnd}
          />
        ))}
      </Layer>
    </Stage>
  );
};

export default App;